<?php
/**
 * pragmaMx - Recipe Module
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.4 $
 * $Author: tora60 $
 * $Date: 2011/11/20 08:57:46 $
 */

defined('mxMainFileLoaded') or die('access denied');

/* --------- Konfiguration fuer den Block ----------------------------------- */

/* max Anzahl der Rezeptkategorien, die angezeigt werden sollen */
$entries = 30;

/* Sortierung der Kategorien, mgliche Werte:
 - 'alpha' fr alphabetische Sortierung > aufsteigend
 - 'count' fr Anzahl der enthaltenen Rezepte > absteigend
 */
$order = 'alpha';

/* zugehriger Modulname */
$modname = 'recipes';

/* Block kann gecached werden? */
$mxblockcache = true;

/* --------- Ende der Konfiguration ----------------------------------------- */

extract($block['settings'], EXTR_OVERWRITE);

require_once (PMX_MODULES_DIR . DS . $modname . DS . 'includes' . DS . 'class.recipe.php');

if (!class_exists('pmxRecipe_Block_Categories', false)) {
    class pmxRecipe_Block_Categories extends pmxRecipe {
        private $settings;

        public function __construct($globals)
        {
            parent::__construct();

            $this->settings = $globals;
        }

        public function show()
        {
            extract($this->settings, EXTR_OVERWRITE);

            switch ($order) {
                case 'count':
                    $sortorder = 'cnt DESC';
                    break;
                case 'alpha':
                default:
                    $sortorder = 'cat.catname ASC';
            }

            $sql = "SELECT cat.cid, cat.catname, COUNT(rec.id) AS cnt
                FROM `$this->_dbtable_cat` AS cat
                INNER JOIN `$this->_dbtable_rec` AS rec ON rec.cid = cat.cid
                WHERE rec.submittime <= NOW()
                GROUP BY cat.catname
                ORDER BY " . $sortorder . "
                LIMIT " . intval($entries);
            $result = sql_query($sql);

            $content = '';
            while (list($cid, $title, $cnt) = sql_fetch_row($result)) {
                $vcnt = ($order == 'count') ? ' (' . $cnt . ')' : '';
                $content .= '<li><a href="modules.php?name=' . $modname . '&amp;cid=' . $cid . '" title="' . $cnt . ' Rezepte">' . trim($title) . $vcnt . '</a></li>';
            }

            if ($content) {
                $content = '<ul class="list">' . $content . '</ul>';
            }

            return $content;
        }
    }
}

$tmp = new pmxRecipe_Block_Categories(get_defined_vars());
$content = $tmp->show();
$tmp = null;

?>
