<?php
/**
 * pragmaMx - Recipe Module
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.2 $
 * $Author: tora60 $
 * $Date: 2011/11/20 08:57:46 $
 */

defined('mxMainFileLoaded') or die('access denied');

/* --------- Konfiguration fuer den Block ----------------------------------- */

/* Anzahl der Rezeptueberschriften, die angezeigt werden sollen */
$numartikel = 9;

/* Ausgabe scrollen? 0 = nein, 1 = ja */
$scrolling = 0;

/* Hoehe des Ausgabebereichs beim Scrollen */
$hoehe = 100;

/* Modulname */
$modname = "recipes";

/* Block kann gecached werden? */
$mxblockcache = true;

/* --------- Ende der Konfiguration ----------------------------------------- */

extract($block['settings'], EXTR_OVERWRITE);

require_once (PMX_MODULES_DIR . DS . $modname . DS . 'includes' . DS . 'class.recipe.php');

if (!class_exists('pmxRecipe_Block_Newest', false)) {
    class pmxRecipe_Block_Newest extends pmxRecipe {
        private $settings;

        public function __construct($globals)
        {
            parent::__construct();

            $this->settings = $globals;
        }

        public function show()
        {
            extract($this->settings, EXTR_OVERWRITE);

            $qry = "SELECT id, recipename
                    FROM `$this->_dbtable_rec`
                    WHERE cid > 0
                     AND submittime <= NOW()
                    ORDER BY submittime DESC
                    LIMIT " . intval($numartikel);
            $result = sql_query($qry);

            $show = '';
            while (list($id, $title) = sql_fetch_row($result)) {
                $show .= '<li><a href="modules.php?name=' . $modname . '&amp;recipe=' . $id . '">' . trim($title) . '</a></li>';
            }

            $content = '';
            if ($show) {
                if ($scrolling) {
                    $content .= "<marquee behavior=\"scroll\" align=\"left\" direction=\"up\" height=\"" . $hoehe . "\" scrollamount= \"2\" scrolldelay= \"90\" onmouseover='this.stop()' onmouseout='this.start()'>";
                }

                $content .= '<ul class="list">' . $show . '</ul>';
                if ($scrolling) {
                    $content .= "</marquee>";
                }
            }

            return $content;
        }
    }
}

$tmp = new pmxRecipe_Block_Newest(get_defined_vars());
$content = $tmp->show();
$tmp = null;

?>
