<?php
/**
 * pragmaMx - Recipe Module
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.2 $
 * $Author: tora60 $
 * $Date: 2011/11/20 08:57:46 $
 */

defined('mxMainFileLoaded') or die('access denied');

/* --------- Konfiguration fuer den Block ----------------------------------- */

/* Anzahl der Rezeptueberschriften, die angezeigt werden sollen */
$numartikel = 9;

/* Modulname */
$modname = "recipes";

/* Block kann gecached werden? */
$mxblockcache = true;

/* --------- Ende der Konfiguration ----------------------------------------- */

extract($block['settings'], EXTR_OVERWRITE);

require_once (PMX_MODULES_DIR . DS . $modname . DS . 'includes' . DS . 'class.recipe.php');

if (!class_exists('pmxRecipe_Block_Random', false)) {
    class pmxRecipe_Block_Random extends pmxRecipe {
        private $settings;

        public function __construct($globals)
        {
            parent::__construct();

            $this->settings = $globals;
        }

        public function show()
        {
            extract($this->settings, EXTR_OVERWRITE);

            $qry = "SELECT *
                    FROM `$this->_dbtable_rec`
                    WHERE (description<>'' OR photo<>'')
                      AND cid > 0
                      AND submittime <= NOW()
                    ORDER BY RAND() DESC
                    LIMIT 1";
            $result = sql_query($qry);

            $row = sql_fetch_assoc($result);

            if (!$row) {
                return '';
            }

            $content = '<h4 class="align-center"><a href="modules.php?name=' . $modname . '&amp;recipe=' . $row['id'] . '">' . $row['recipename'] . '</a></h4>';
            if ($row['photo']) {
                $content .= '<a href="modules.php?name=' . $modname . '&amp;recipe=' . $row['id'] . '">';
                $content .= strip_tags($this->get_photo_imagetag($row, 'small', 'align-center'), '<img>');
                $content .= '</a>';
            } else {
                $content .= '<p>' . $row['description'] . '</p>';
            }

            return $content;
        }
    }
}

$tmp = new pmxRecipe_Block_Random(get_defined_vars());
$content = $tmp->show();
$tmp = null;

?>
