<?php
/**
 * pragmaMx - Recipe Module
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.9 $
 * $Author: tora60 $
 * $Date: 2011/11/20 14:05:24 $
 *
 * this module based on: PHP-NUKE Recipe Module
 * Copyright (c) 2003 by Sean Pluard , http://heartstorm.org
 * modified by jubilee (http://www.marx-city.de) and kochloeffel
 */

defined('mxMainFileLoaded') or die('access denied');

require_once(dirname(dirname(__FILE__)) . DS . 'includes' . DS . 'class.recipe.php');

/**
 * pmxRecipe_admin
 *
 * @package
 * @author tora60
 * @copyright Copyright (c) 2011
 * @version $Id: admin.php,v 1.9 2011/11/20 14:05:24 tora60 Exp $
 * @access public
 */
class pmxRecipe_admin extends pmxRecipe {
    protected $op = '';

    /**
     * pmxRecipe_admin::__construct()
     */
    public function __construct()
    {
        parent::__construct();

        if (!$this->_is_admin) {
            return mxredirect('modules.php?name=' . $this->_module_name, _GROUPRESTRICTEDAREA);
        }

        $admindata = mxGetAdminSession();
        $this->_adminmode = true;

        $this->op = (empty($_REQUEST['op'])) ? '' : rtrim($_REQUEST['op'], ' /');
        switch ($this->op) {
            case 'recipe/cat':
                return $this->cat();

            case 'recipe/cat/save':
                return $this->cat_save();

            case 'recipe/add':
                return $this->add();

            case 'recipe/add/send':
                return $this->add_send();

            case 'recipe/del':
            // return $this->del_send();
            case 'recipe/del/send':
                return $this->del_send();

            case 'recipe/edit':
                return $this->edit();

            case 'recipe/edit/send':
                return $this->edit_send();

            case 'recipe/setup':
                return $this->setup();

            case 'recipe':
            default:
                $this->op = 'recipe/cat';
                return $this->cat();
        }
    }

    /**
     * pmxRecipe_admin::setup()
     *
     * @return
     */
    public function setup()
    {
        require_once(dirname(__FILE__) . DS . 'setup.php');
        ob_start();
        $tmp = new pmxRecipe_setup();
        $tmp = null;

        $out = ob_get_clean();
        return $this->adminpage($out);
    }

    /**
     * pmxRecipe_admin::adminpage()
     *
     * @param mixed $content
     * @return
     */
    public function adminpage($content)
    {
        /* rechte Blcke anzeigen */
        // $index = $this->right_blocks;
        pmxHeader::add_style(PMX_MODULES_PATH . $this->_module_name . '/style/style.css');
        // TODO: !!!!!!!!!!!!!!!
        $GLOBALS['pagetitle'] = $this->modtitle;

        $this->_template->assign('op', $this->op);
        $this->_template->assign('content', $content);
        $this->_template->assign('messages', $this->_messages);
        $this->_template->assign('errors', $this->_errors);

        include_once('header.php');
        GraphicAdmin();
        $this->_template->display('adminpage.html');
        include_once('footer.php');
    }

    /**
     * pmxRecipe_admin::edit_view_category()
     *
     * @return
     */
    public function edit_view_category()
    {
        $cid = intval($_GET['cid']);

        $sql = "SELECT rec.*, cat.catname
                    FROM `$this->_dbtable_rec` AS rec
                    LEFT JOIN `$this->_dbtable_cat` AS cat
                    ON rec.cid = cat.cid
                    WHERE rec.cid = " . intval($cid) . "
                    ORDER BY recipename,submittime";
        $result = sql_query($sql);
        $rowset = array();
        while ($row = sql_fetch_assoc($result)) {
            $rowset[] = $row;
            $caption = $row['catname'];
        }

        switch (true) {
            case $cid === 0:
                $caption = _INACTIVE;
                break;
            case empty($caption):
                $caption = _REC_NORECIPESFOUNDCATEGORY;
                break;
            default:
                $caption = _REC_CATEGORY . ': ' . $caption;
        }

        /* Template ausgeben */
        $this->_template->assign(compact('rowset', 'caption'));
        $out = $this->_template->fetch('admin_list_entries.html');

        return $out;
    }

    /**
     * pmxRecipe_admin::edit_view_search()
     *
     * @return
     */
    public function edit_view_search()
    {
        $query = (isset($_GET['query'])) ? $_GET['query'] : '';

        $rowset = array();
        if (isset($_GET['query'])) {
            $sql = "SELECT rec.*, cat.catname
                    FROM `$this->_dbtable_rec` AS rec
                    LEFT JOIN `$this->_dbtable_cat` AS cat
                    ON rec.cid = cat.cid
                    WHERE rec.recipename LIKE '%" . mxAddSlashesForSQL($query) . "%'
                    ORDER BY rec.recipename, rec.submittime";
            $result = sql_query($sql);
            $rowset = array();
            while ($row = sql_fetch_assoc($result)) {
                if (!$row['catname'] || !$row['cid']) {
                    $row['catname'] = _INACTIVE;
                }
                $rowset[] = $row;
            }
        }

        $this->_template->assign(compact('rowset', 'query'));
        $out = $this->_template->fetch('admin_view_search.html');

        return $out;
    }

    /**
     * pmxRecipe_admin::edit()
     *
     * @return
     */
    public function edit($data = array())
    {
        $out = '';

        switch (true) {
            case isset($_GET['cid']):
                /* Kategorie auflisten */
                $out = $this->edit_view_category();
                break;

            case $data:
                $id = intval($data['id']);
                $row = $this->recipe_get_data($id);
                $row = array_merge($this->_defaults, $row, $data);
                $out = $this->recipe_form($row);
                break;

            case isset($_GET['id']):
                /* nderungs-Formular anzeigen */
                $id = intval($_GET['id']);
                $row = $this->recipe_get_data($id);
                $row = array_merge($this->_defaults, $row);
                $out = $this->recipe_form($row);
                break;

            case isset($_GET['query']):
            default:
                /* Suche oder Suchergebnisse anzeigen */
                $out = $this->edit_view_search();
        }

        return $this->adminpage($out);
    }

    /**
     * pmxRecipe_admin::edit_send()
     *
     * @return
     */
    public function edit_send()
    {
        $id = (isset($_POST['id'])) ? intval($_POST['id']) : 0;
        $row = $this->recipe_get_data($id);

        if (isset($_POST['submittime']) && ($tmpdate = strtotime($_POST['submittime']))) {
            $_POST['submittime'] = date('Y-m-d', $tmpdate) . date(' H:i:s');
        } else {
            unset($_POST['submittime']);
        }

        $data = array_merge($this->_defaults, $row, $_POST);

        $this->edit_send_save($data);

        if ($this->_errors) {
            mxStripSlashes($data);
            return $this->edit($data);
        }

        return mxredirect('admin.php?op=recipe/edit&id=' . $id, implode('', $this->_messages));
    }

    /**
     * pmxRecipe_admin::add()
     *
     * @return
     */
    public function add($data = array())
    {
        $data = array_merge($this->_defaults, $data);

        $out = $this->recipe_form($data);
        return $this->adminpage($out);
    }

    /**
     * pmxRecipe_admin::add_send()
     *
     * @return
     */
    public function add_send()
    {
        if (isset($_POST['submittime']) && ($tmpdate = strtotime($_POST['submittime']))) {
            $_POST['submittime'] = date('Y-m-d', $tmpdate) . date(' H:i:s');
        } else {
            unset($_POST['submittime']);
        }

        $data = array_merge($this->_defaults, $_POST);

        $id = $this->add_send_save($data);

        if (!$id || $this->_errors) {
            mxStripSlashes($data);
            return $this->add($data);
        }

        return mxredirect('admin.php?op=recipe/edit&amp;id=' . $id, implode('', $this->_messages));
    }

    /**
     * pmxRecipe_admin::del_send()
     *
     * @return
     */
    public function del_send()
    {
        $id = (isset($_GET['id'])) ? intval($_GET['id']) : 0;
        $row = $this->recipe_get_data($id);

        $ok = $this->del_send_save($id, $row);

        $lasturl = mxSessionGetVar('lasturl');
        if (!$lasturl) {
            $lasturl = 'admin.php?op=recipe';
        }

        return mxredirect($lasturl, implode('', $this->_messages));
    }

    /**
     * pmxRecipe_admin::cat()
     *
     * @return
     */
    public function cat()
    {
        $sql = "SELECT cat.cid, cat.catname, COUNT(rec.id) AS cnt
                FROM `$this->_dbtable_cat` AS cat
                LEFT JOIN `$this->_dbtable_rec` AS rec ON rec.cid = cat.cid
                GROUP BY cat.catname
                ORDER BY cat.catname";
        $result = sql_query($sql);
        $categories = array();
        while ($row = sql_fetch_assoc($result)) {
            $categories[] = $row;
        }

        $sql = "SELECT COUNT(id) AS cnt FROM `$this->_dbtable_rec` WHERE cid=0";
        $result = sql_query($sql);
        list($deactives) = sql_fetch_row($result);

        $this->_template->assign(compact('row', 'categories', 'deactives'));
        $out = $this->_template->fetch('cat.html');
        return $this->adminpage($out);
    }

    /**
     * pmxRecipe_admin::cat_save()
     *
     * @return
     */
    public function cat_save()
    {
        /* Lschen */
        if (isset($_REQUEST['del'])) {
            $del = array();
            foreach ($_REQUEST['del'] as $cid => $val) {
                if ($val) {
                    $del[] = intval($cid);
                }
            }
            if ($del) {
                $sql = "DELETE FROM `$this->_dbtable_cat` WHERE cid IN(" . implode(',', $del) . ")";
                $result = sql_query($sql);
                $sql = "UPDATE `$this->_dbtable_rec` SET cid=0 WHERE cid IN(" . implode(',', $del) . ")";
                $result = sql_query($sql);
            }
        }

        /* nderungen */
        if (isset($_REQUEST['edit']) && isset($_REQUEST['old'])) {
            $result = array_diff($_REQUEST['edit'], $_REQUEST['old']);
            foreach ($result as $cid => $catname) {
                $sql = "UPDATE `$this->_dbtable_cat` SET catname='" . mxAddSlashesForSQL($catname) . "' WHERE cid=" . intval($cid);
                $result = sql_query($sql);
            }
        }

        /* Neuanlage */
        if (isset($_REQUEST['add'])) {
            foreach ($_REQUEST['add'] as $catname) {
                if ($catname) {
                    $sql = "INSERT INTO `$this->_dbtable_cat` (catname) VALUES ('" . mxAddSlashesForSQL($catname) . "')";
                    $result = sql_query($sql);
                }
            }
        }

        return mxredirect('admin.php?op=recipe/cat', _CHANGESAREOK);
    }
}

$tmp = new pmxRecipe_admin();
$tmp = null;

?>
