<?php
/**
 * pragmaMx - Web recipes Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.1 $
 * $Author: tora60 $
 * $Date: 2011/09/18 13:52:53 $
 */

/* falls die Datei direkt aufgerufen, das include einfach beenden */
if (!defined('PMX_HOME_URL')) return;
class_exists('pmxModrewrite', false) or die('access denied');



/*
# Eintrag fr .htaccess:

# Rezepte
RewriteRule ^Rezeptkategorie-([0-9]+)(-.*)?\.html$ mod.php?name=recipes&cid=$1&_MORE_=$2 [L]
RewriteRule ^Rezept-([0-9]+)(-.*)?\.html$ mod.php?name=recipes&recipe=$1&_MORE_=$2 [L]

*/

class pmxModrewrite_recipes extends pmxModrewrite {
    public function get($name, $parameter)
    {
        global $prefix;

        $replaces = array();

        $cat = array();
        $recipe = array();

        foreach ($parameter as $key => $para) {
            switch (true) {
                case (isset($para['cid']) && intval($para['cid'])):
                    $cat[0][] = $para['cid'];
                    $cat[$key] = $para;
                    break;
                case (isset($para['recipe']) && intval($para['recipe'])):
                    $recipe[0][] = $para['recipe'];
                    $recipe[$key] = $para;
                    break;
            }
        }

        /**
         * Rezeptkategorie-{cid}-KATEGORIENAME.html
         * RewriteRule ^Rezeptkategorie-([0-9]+)(-.*)?\.html$ mod.php?name=recipes&cid=$1&_MORE_=$2 [L]
         */
        if ($cat) {
            $inquery = implode(',', array_unique(array_shift($cat)));
            $qry = "SELECT cid, catname FROM {$prefix}_recipes_categories WHERE cid in ($inquery)";
            $result = sql_query($qry);
            $catnames = array();
            while (list($cid, $catname) = sql_fetch_row($result)) {
                $catnames[$cid] = parent::title_entities($catname, '-');
            }

            foreach ($cat as $key => $link) {
                if (isset($catnames[$link['cid']])) {
                    $new_url = parent::title_parameters($link, 'cid');
                    $new_url = 'Rezeptkategorie-' . $link['cid'] . '--' . $catnames[$link['cid']] . $new_url;
                    $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
                }
            }
        }

        /**
         * Rezept-{id}-REZEPTNAME.html
         * RewriteRule ^Rezept-([0-9]+)(-.*)?\.html$ mod.php?name=recipes&recipe=$1&_MORE_=$2 [L]
         */
        if ($recipe) {
            $inquery = implode(',', array_unique(array_shift($recipe)));
            $qry = "SELECT id, recipename FROM {$prefix}_recipes WHERE id in ($inquery)";
            $result = sql_query($qry);
            $recipenames = array();
            while (list($id, $recipename) = sql_fetch_row($result)) {
                $recipenames[$id] = parent::title_entities($recipename, '-');
            }

            foreach ($recipe as $key => $link) {
                if (isset($recipenames[$link['recipe']])) {
                    $new_url = parent::title_parameters($link, 'recipe');
                    $new_url = 'Rezept-' . $link['recipe'] . '--' . $recipenames[$link['recipe']] . '' . $new_url;
                    $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
                }
            }
        }

        return $replaces;
    }
}

?>