<?php
/**
 * pragmaMx - Recipe Module
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.10 $
 * $Author: tora60 $
 * $Date: 2011/11/20 11:39:08 $
 *
 * this module based on: PHP-NUKE Recipe Module
 * Copyright (c) 2003 by Sean Pluard , http://heartstorm.org
 * modified by jubilee (http://www.marx-city.de) and kochloeffel
 */

defined('mxMainFileLoaded') or die('access denied');

require_once(dirname(__FILE__) . DS . 'includes' . DS . 'class.recipe.php');

/**
 * pmxRecipe_user
 *
 * @package
 * @author tora60
 * @copyright Copyright (c) 2011
 * @version $Id: index.php,v 1.10 2011/11/20 11:39:08 tora60 Exp $
 * @access public
 */
class pmxRecipe_user extends pmxRecipe {
    /**
     * pmxRecipe_user::__construct()
     */
    public function __construct()
    {
        parent::__construct();

        switch (true) {
            case !isset($_REQUEST['op']) && isset($_GET['letter']):
            case isset($_REQUEST['action']) && isset($_GET['query']) && $_REQUEST['action'] == 'alphabrowse': // alter Aufruf
                return $this->alphabrowse();

            case !isset($_REQUEST['op']) && isset($_GET['recipe']):
            case isset($_REQUEST['action']) && isset($_GET['recipeid']) && $_REQUEST['action'] == 'viewrecipe': // alter Aufruf
                return $this->viewrecipe();

            case !isset($_REQUEST['op']) && isset($_GET['print']):
                return $this->printrecipe();

            case !isset($_REQUEST['op']):
            case isset($_REQUEST['action']) && $_REQUEST['action'] == 'categorybrowsestart':// alter Aufruf
            case isset($_REQUEST['action']) && isset($_GET['query']) && $_REQUEST['action'] == 'categorybrowse':// alter Aufruf
                return $this->categorybrowse();

            case 'search' == $_REQUEST['op']:
                return $this->search();

            case 'add' == $_REQUEST['op']:
                return $this->add();

            case 'add/send' == $_REQUEST['op']:
                return $this->add_send();

            case 'delete' == $_REQUEST['op']:
                return $this->del_send();

            case 'edit' == $_REQUEST['op']:
                return $this->edit();

            case 'edit/send' == $_REQUEST['op']:
                return $this->edit_send();

            case 'email' == $_REQUEST['op']:
                return $this->mailrecipe();

            case 'email/send' == $_REQUEST['op']:
                return $this->mailrecipe_send();

            default:
                return $this->categorybrowse();
        }
    }

    /**
     * pmxRecipe_user::page()
     *
     * @param mixed $content
     * @return
     */
    public function page($content)
    {
        global $index;

        /* rechte Blcke anzeigen */
        $index = $this->right_blocks;

        pmxHeader::add_style(PMX_MODULES_PATH . $this->_module_name . '/style/style.css');
        // TODO: !!!!!!!!!!!!!!!
        $GLOBALS['pagetitle'] = $this->modtitle;

        $reporter = $this->has_edit_access($this->_user['uname']);

        $alpha = $this->alpha();

        $this->_template->assign(compact('content', 'reporter', 'alpha'));
        // $this->_template->assign('user_name', $this->_user['uname']);
        $this->_template->assign('messages', $this->_messages);
        $this->_template->assign('errors', array_filter(array_unique($this->_errors)));

        include_once('header.php');
        title($this->modtitle);
        OpenTable();
        $this->_template->display('page.html');
        CloseTable();
        include_once('footer.php');
    }

    /**
     * pmxRecipe_user::printrecipe()
     *
     * @return
     */
    public function printrecipe()
    {
        global $sitename;

        $id = (isset($_GET['print'])) ? intval($_GET['print']) : 0;
        $row = $this->recipe_get_data_for_view($id);

        switch (true) {
            case !$id:
            case !$row:
            case $this->_errors:
                return $this->viewrecipe($id);
        }

        $target = PMX_HOME_URL . '/modules.php?name=' . $this->_module_name . '&recipe=' . $id;

        $this->_template->assign($row);
        $this->_template->assign(compact('row', 'class', 'sitename', 'target'));
        $this->_template->display('print.html');
    }

    /**
     * pmxRecipe_user::alphabrowse()
     *
     * @return
     */
    public function alphabrowse()
    {
        switch (true) {
            case isset($_GET['letter']):
                $query = substr($_GET['letter'], 0, 1);
                break;
            case isset($_GET['query']):
                // alter Aufruf
                $query = substr($_GET['query'], 0, 1);
                break;
            default:
                $query = 'A';
        }

        $sql = "SELECT rec.*, cat.catname
                FROM `$this->_dbtable_rec` AS rec
                LEFT JOIN `$this->_dbtable_cat` AS cat
                ON rec.cid = cat.cid
                WHERE rec.recipename like '" . mxAddSlashesForSQL($query) . "%'
                 AND rec.submittime <= NOW()
                ORDER BY recipename,submittime";
        $result = sql_query($sql);

        $rowset = array();
        while ($row = sql_fetch_assoc($result)) {
            if ($row['cid'] || $this->has_edit_access($row['contributer'])) {
                $rowset[] = $row;
            }
        }
        if (!$rowset) {
            return mxredirect('modules.php?name=' . $this->_module_name, _REC_NORECIPESFOUNDSTARTING . " '$query'.");
        }

        $out = $this->list_entries($rowset);
        return $this->page($out);
    }

    /**
     * pmxRecipe_user::categorybrowse()
     *
     * @return
     */
    public function categorybrowse()
    {
        switch (true) {
            case isset($_GET['cid']):
                $cid = intval($_GET['cid']);
                break;
            case isset($_GET['query']):
                // alter Aufruf
                $sql = "SELECT cid FROM `$this->_dbtable_cat` WHERE catname = '" . mxAddSlashesForSQL($_GET['query']) . "' ";
                $result = sql_query($sql);
                list($cid) = sql_fetch_row($result);
                break;
            default:
                $cid = 0;
        }

        $sql = "SELECT cat.cid, cat.catname, COUNT(rec.id) AS cnt
                FROM `$this->_dbtable_cat` AS cat
                INNER JOIN `$this->_dbtable_rec` AS rec ON rec.cid = cat.cid
                GROUP BY cat.catname
                ORDER BY cat.catname";
        $result = sql_query($sql);

        $entries = array();
        $options = array();
        if ($this->_is_admin) {
            $options[] = "<option value=''> -- " . _INACTIVE . " -- </option>";
        }
        /* while */
        while ($row = sql_fetch_assoc($result)) {
            if ($row['cid']) {
                $sel = ($cid == $row['cid']) ? ' selected="selected" class="current"' : '';
                $options[] = '<option value="' . $row['cid'] . '"' . $sel . '>' . $row['catname'] . '</option>';
                $entries[] = '<li><h4 class="box"><a href="modules.php?name=' . $this->_module_name . '&amp;cid=' . intval($row['cid']) . '">' . $row['catname'] . '</a></h4></li>';
            }
        }

        $this->_template->assign(compact('cid', 'options', 'entries'));

        $out = '';
        $caption = '';
        if ($options && $cid) {
            $sql = "SELECT rec.*, cat.catname
                    FROM `$this->_dbtable_rec` AS rec
                    LEFT JOIN `$this->_dbtable_cat` AS cat
                    ON rec.cid = cat.cid
                    WHERE rec.cid = " . intval($cid) . "
                     AND rec.submittime <= NOW()
                    ORDER BY rec.recipename,rec.submittime";
            $result = sql_query($sql);
            $rowset = array();
            while ($row = sql_fetch_assoc($result)) {
                if ($row['cid'] || $this->has_edit_access($row['contributer'])) {
                    $rowset[] = $row;
                }
                if ($row['cid']) {
                    $caption = $row['catname'];
                }
            }

            if ($rowset) {
                $content = $this->list_entries($rowset);
            } else {
                $content = '';
            }

            /* Template ausgeben */
            $this->_template->assign(compact('rowset', 'content', 'caption'));
            $out = $this->_template->fetch('categorybrowse2.html');
        } else if ($entries) {
            /* Template ausgeben */
            $out = $this->_template->fetch('categorybrowse1.html');
        }

        return $this->page($out);
    }

    public function viewrecipe($id = 0)
    {
        switch (true) {
            case isset($_GET['recipe']):
                $id = intval($_GET['recipe']);
                break;
            case isset($_GET['recipeid']):
                // alter Aufruf
                $id = intval($_GET['recipeid']);
                break;
        }

        $row = $this->recipe_get_data_for_view($id);

        if ($this->_errors) {
            return $this->page('');
        }

        $reporter = $this->has_edit_access($row['contributer']);
        // $link['cid'] = array('url'=>'modules.php?name=' . $this->_module_name . '&amp;cid=' . $row['cid'], 'caption'=>_REC_CATEGORY.'&nbsp;'.$row['catname']);
        $link['print'] = array('url' => 'modules.php?name=' . $this->_module_name . '&amp;print=' . $row['id'], 'caption' => _REC_PRINTERFRIENDLY);
        if ($this->_sendmail_allowed()) {
            $link['send'] = array('url' => 'modules.php?name=' . $this->_module_name . '&amp;op=email&amp;id=' . $row['id'], 'caption' => _REC_EMAILRECIPE);
        }
        if ($reporter) {
            $link['edit'] = array('url' => 'modules.php?name=' . $this->_module_name . '&amp;op=edit&amp;id=' . $row['id'], 'caption' => _REC_EDITRECIPE);
            $link['delete'] = array('url' => 'modules.php?name=' . $this->_module_name . '&amp;op=delete&amp;id=' . $row['id'], 'caption' => _REC_DELETERECIPE);
        }

        $this->_template->assign(compact('row', 'reporter'));
        $this->_template->assign($row);
        $content = $this->_template->fetch('view.html');

        $this->_template->assign(compact('content', 'link', 'reporter'));
        $out = $this->_template->fetch('viewrecipe.html');
        return $this->page($out);
    }

    /**
     * pmxRecipe_user::search()
     *
     * @return
     */
    public function search()
    {
        $query = (isset($_GET['query'])) ? $_GET['query'] : '';
        $check = array('', '', '');
        switch (true) {
            case !isset($_GET['field']):
            case $_GET['field'] == 'name':
            default:
                $check[0] = ' checked="checked"';
                $_GET['field'] = 'name';
                $fieldname = 'recipename';
                break;
            case $_GET['field'] == 'ingredients':
                $check[1] = ' checked="checked"';
                $fieldname = 'ingredients';
                break;
            case $_GET['field'] == 'user':
                $check[2] = ' checked="checked"';
                $fieldname = 'contributer';
                break;
        }

        $rowset = array();
        if (isset($_GET['query'])) {
            $sql = "SELECT rec.*, cat.catname
                    FROM `$this->_dbtable_rec` AS rec
                      LEFT JOIN `$this->_dbtable_cat` AS cat
                      ON rec.cid = cat.cid
                    WHERE " . $fieldname . " LIKE '%" . mxAddSlashesForSQL($query) . "%'
                     AND rec.submittime <= NOW()
                    ORDER BY rec.recipename,rec.submittime";
            $result = sql_query($sql);
            $rowset = array();
            while ($row = sql_fetch_assoc($result)) {
                if ($row['cid'] || $this->has_edit_access($row['contributer'])) {
                    $rowset[] = $row;
                }
            }
        }

        if ($rowset) {
            $content = $this->list_entries($rowset);
        } else {
            $content = '';
        }

        $this->_template->assign(compact('content', 'query', 'check'));
        $out = $this->_template->fetch('search.html');

        return $this->page($out);
    }

    /**
     * pmxRecipe_user::edit()
     *
     * @return
     */
    public function edit($data = array())
    {
        switch (true) {
            case $data:
                $id = intval($data['id']);
                $row = $this->recipe_get_data($id);
                $row = array_merge($this->_defaults, $row, $data);
                break;

            case isset($_GET['id']):
                /* nderungs-Formular anzeigen */
                $id = intval($_GET['id']);
                $row = $this->recipe_get_data($id);
                $row = array_merge($this->_defaults, $row);
                break;
        }

        if (!$this->has_edit_access($row['contributer'])) {
            return mxredirect('modules.php?name=' . $this->_module_name . '&recipe=' . $row['id'], _REC_NOCONTRIBEDIT);
        }

        $out = $this->recipe_form($row);
        return $this->page($out);
    }

    /**
     * pmxRecipe_user::edit_send()
     *
     * @return
     */
    public function edit_send()
    {
        $id = (isset($_POST['id'])) ? intval($_POST['id']) : 0;
        $row = $this->recipe_get_data($id);

        if (!$this->has_edit_access($row['contributer'])) {
            return mxredirect('modules.php?name=' . $this->_module_name, _REC_NOCONTRIBEDIT);
        }

        if (isset($_POST['submittime']) && ($tmpdate = strtotime($_POST['submittime']))) {
            $_POST['submittime'] = date('Y-m-d', $tmpdate) . date(' H:i:s');
        } else {
            unset($_POST['submittime']);
        }

        $data = array_merge($this->_defaults, $row, $_POST);

        $this->edit_send_save($data);

        if ($this->_errors) {
            mxStripSlashes($data);
            return $this->edit($data);
        }

        return mxredirect('modules.php?name=' . $this->_module_name . '&recipe=' . $id, implode('', $this->_messages));
    }

    /**
     * pmxRecipe_user::add()
     *
     * @return
     */
    public function add($data = array())
    {
        if (!$this->has_edit_access($this->_user['uname'])) {
            return mxredirect('modules.php?name=' . $this->_module_name, _GROUPRESTRICTEDAREA);
        }

        $data = array_merge($this->_defaults, $data);

        $out = $this->recipe_form($data);
        return $this->page($out);
    }

    /**
     * pmxRecipe_user::add_send()
     *
     * @return
     */
    public function add_send()
    {
        if (!$this->has_edit_access($this->_user['uname'])) {
            return mxredirect('modules.php?name=' . $this->_module_name , _GROUPRESTRICTEDAREA);
        }

        if (isset($_POST['submittime']) && ($tmpdate = strtotime($_POST['submittime']))) {
            $_POST['submittime'] = date('Y-m-d', $tmpdate) . date(' H:i:s');
        } else {
            unset($_POST['submittime']);
        }

        $data = array_merge($this->_defaults, $_POST);

        $id = $this->add_send_save($data);

        if (!$id || $this->_errors) {
            mxStripSlashes($data);
            return $this->add($data);
        }

        return mxredirect('modules.php?name=' . $this->_module_name . '&recipe=' . $id, implode('', $this->_messages));
    }

    /**
     * pmxRecipe_user::del_send()
     *
     * @return
     */
    public function del_send()
    {
        $id = (isset($_GET['id'])) ? intval($_GET['id']) : 0;
        $row = $this->recipe_get_data($id);

        if (!$this->has_edit_access($row['contributer'])) {
            return mxredirect('modules.php?name=' . $this->_module_name, _REC_NOCONTRIBDELETE);
        }

        $ok = $this->del_send_save($id, $row);

        return mxredirect('modules.php?name=' . $this->_module_name, implode('', $this->_messages));
    }

    /**
     * pmxRecipe_user::mailrecipe()
     *
     * @param array $data
     * @return
     */
    public function mailrecipe($data = array())
    {
        $data = array_merge($this->_maildefaults(), $data);
        extract($data);

        $id = (isset($_GET['id'])) ? intval($_GET['id']) : intval($id);

        if (!$this->_sendmail_allowed()) {
            return mxredirect('modules.php?name=' . $this->_module_name . '&recipe=' . $id , '<div class="align-left">' . _MODULEUSERS . '</div>');
        }

        $row = $this->recipe_get_data_for_view($id);

        $captcha = load_class('Captcha');
        $captcha->set_active($this->captcha_mail);

        $this->_template->assign(compact('captcha', 'id', 'recipient', 'sendername', 'sendermail', 'comment'));
        $this->_template->assign($row);
        $out = $this->_template->fetch('email_form.html');

        return $this->page($out);
    }

    /**
     * pmxRecipe_user::mailrecipe_send()
     *
     * @return
     */
    public function mailrecipe_send()
    {
        global $sitename;

        $data = array_merge($this->_maildefaults(), $_POST);

        extract($data);

        $row = $this->recipe_get_data_for_view($id);

        switch (true) {
            case !$id:
            case !$row:
                $this->_errors[] = _REC_MAILERR1;
                return $this->viewrecipe($id);
            case !$this->_sendmail_allowed():
                return mxredirect('modules.php?name=' . $this->_module_name . '&recipe=' . $id , '<div class="align-left">' . _MODULEUSERS . '</div>');
            case $this->_errors:
                return $this->viewrecipe($id);
        }

        if (!$recipient || !mxCheckEmail($recipient)) {
            $this->_errors[] = _REC_MAILERR2;
        }

        if (!$sendername || !$sendermail || !mxCheckEmail($sendermail)) {
            $this->_errors[] = _REC_MAILERR3;
        }
        // captcha pruefen
        $captcha = load_class('Captcha');
        $captcha->set_active($this->captcha_mail);
        if ($this->captcha_mail && !$captcha->check($_POST, 'captcha')) {
            $this->_errors[] = _CAPTCHAWRONG;
        }

        $comment = strip_tags($comment);

        $target = PMX_HOME_URL . '/modules.php?name=' . $this->_module_name . '&recipe=' . $id;

        $data = compact('sitename', 'id', 'recipient', 'sendername', 'sendermail', 'comment', 'target');

        if ($this->_errors) {
            return $this->mailrecipe($data);
        }

        $this->_template->assign($data);
        $this->_template->assign($row);
        $body = $this->_template->fetch('email_content.html');
        $body = strip_tags($body);
        $subject = sprintf(_REC_MAILSUBJECT, $sitename);

        $ok = mxMail($recipient, $subject, $body, $sendermail);

        if ($ok) {
            $this->_messages[] = _REC_RECIPESENT;
        } else {
            $this->_errors[] = _REC_SENDERROR;
        }

        return $this->viewrecipe($id);
    }

    /**
     * pmxRecipe_user::_maildefaults()
     *
     * @return array ()
     */
    private function _maildefaults()
    {
        return array('id' => 0,
            'recipient' => '',
            'comment' => '',
            'sendername' => $this->_user['uname'],
            'sendermail' => $this->_user['email'],
            );
    }
}

$tmp = new pmxRecipe_user();
$tmp = null;

?>
